spec:
  inputs:
    sonarStage:
      description: Sonar Cloud stage
      default: 'test'
    sonarUserHome:
      description: SONAR USER HOME            # Defines the location of the analysis task cache
      default: '${CI_PROJECT_DIR}/.sonar'     
    gitDepth:
      description: GIT DEPTH                  # Tells git to fetch all the branches of the project, required by the analysis task
      default: '0'
    sonarToken:
      description: SONAR TOKEN                # It is unic per project
      default: '7e753f15e0e8887d11c25f82050946d05a23724f'
    sonarHostUrl:
      description: SONAR HOST URL
      default: 'https://sonarcloud.io'
   

---

variables:
  SONAR_USER_HOME: $[[ inputs.sonarUserHome ]]
  GIT_DEPTH: $[[ inputs.gitDepth ]]
  SONAR_TOKEN: $[[ inputs.sonarToken ]]
  SONAR_HOST_URL: $[[ inputs.sonarHostUrl ]]


# Developers READ the Documentation!!!
# https://pypi.org/project/auto-changelog/
# https://www.npmjs.com/package/auto-changelog
# https://github.com/CookPete/auto-changelog  # This is good
generate_changelog:
  stage: changelog
  image: node:14  # Utiliza una imagen de Node.js
  rules:
    - if: $CI_COMMIT_TAG
      when: never
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: on_success
  before_script:
    - npm install -g auto-changelog  # Instala auto-changelog globalmente
  script:
    - auto-changelog -p -v $SEMANTIC_VERSION -l false -t changelog-template.hbs
  artifacts:
    paths:
      - CHANGELOG.md  # El archivo CHANGELOG.md se generará en el directorio raíz del proyecto
  allow_failure: true


release_job:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  needs:
    - job: install                    # Need the SEMANTIC_VERSION variable
      artifacts: true
    - job: generate_changelog         # Need the CHANGELOG.md file
      artifacts: true
  rules:
    - if: $CI_COMMIT_TAG
      when: never                                  # Do not run this job when a tag is created manually
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH  # Run this job when commits are pushed or merged to the default branch
      when: on_success
  before_script:
    - echo "${CI_JOB_NAME}"
  script:
    - echo $SEMANTIC_VERSION
    - echo "running release_job for $SEMANTIC_VERSION"
    - ls -lha
    - echo CHANGELOG.md
    - cat CHANGELOG.md
  release:
    name: 'Release ${SEMANTIC_VERSION}'
    description: "## CHANGELOG\r\n\n\n$(cat CHANGELOG.md)"    # $EXTRA_DESCRIPTION and the ($TAG = $SEMANTIC_VERSION)
    tag_name: '${SEMANTIC_VERSION}'                                                 # variables must be defined elsewhere
    # ref: '$CI_COMMIT_SHA'                                            # in the pipeline. For example, in the
    # assets:
    #   links:
    #     - name: 'ANA Framework ${SEMANTIC_VERSION} release post '
    #       url: 'https://ana-framework.gitlab.io/home/'